Subject: Re: iscsi : Fragmentation & Reassembly issues in iSCSI.

From: [email-masked]
Date: Mon, 22 Jan 2001 08:14:54 +0200

Santosh,

The F bit is used to indicate the end of a sequence that is "sort-of"
atomic (like an R2T or the initial burst).  There might be some parameter
negotiations that we want to be atomic (like the login phase) and we might
end-up using the F bit there. But I will NOT mandate the use of the F bit
in any sequence only due to the (rather academic) fragmentation aspect you
mention. Initiator and target builders should be able to have enough buffer
space for all the keys they use.

Julo

Santosh Rao <[email-masked]> on 21/01/2001 21:29:12

Please respond to Santosh Rao <[email-masked]>

To:   Julian Satran/Haifa/IBM@IBMIL
cc:   [email-masked]
Subject:  Re: iscsi : Fragmentation & Reassembly issues in iSCSI.

> Santosh,
>
> The intent was to enable lower limits for ping and text.  I would be
> reluctant to use the same limit as in some contexts the PDU limit
> could be practically very large. PDU will be limited at first
> by 2 factors - the CRC and the need to limit loss-of-framing
> temporary memory.If and when the underlying transport will have a good
> RDMA mechanism and we will have a decent CRC-64 or we are using
> IPsec the PDU limit could be extremely large.
> We don't want the same to hold for Ping, Text etc.
>
> However we would like to have the PDU limit to hold for all as it is
> mainly meant for framing and CRC.
>
> For all those reasons I suggest limiting the text length also to the
> lower of the two.

Julian,

Agreed. However, it could be the case that the number of login keys being
negotiated exceeds TotalText requiring the use of multiple Text Commands
and Text Responses. An "F" bit is required in bit 7 of byte 1 of the text
and login commands and responses to indicate the last command or response
PDU of the login or text operations to deal with this condition.

Regards,
Santosh
>
> Julo
>
> Santosh Rao <[email-masked]> on 19/01/2001 23:59:49
>
> Please respond to Santosh Rao <[email-masked]>
>
> The fragmentation issue as explained in the above example is also
> applicable for the Login and Text Commands. (TotalText > DataPDULength).
>
> In the case of these commands, a "F" bit is required in bit 7 of byte
> 1 of the command & response PDUs to indicate the last command or
> response PDU due to the fragmentation issues that arise from
> TotalText & DataPDULength.

--
#################################
Santosh Rao
Software Design Engineer,
HP, Cupertino.
email : [email-masked]
Phone : 408-447-3751
#################################